; AutoIt Version: 3.3.0
; Language:       English
; Platform:       Win9x/NT
; Author:         kargas

#NoTrayIcon
#Include <Misc.au3>
#include <File.au3>
#include <array.au3>
#Include <string.au3>
#include <GuiHeader.au3>
#include <GUIConstantsEx.au3>
#Include <GUIComboBox.au3>
#include <WindowsConstants.au3>

$famfilterpac=(@scriptdir & "\familyfilter.pac")
$Find1 = "//dimantibegin"
$Find2= "//dimantiend"


if FileExists($famfilterpac)=0 then
msgbox(48, "FamilyFilter Error", "Familyfilter.pac is missing, please reinstall the extension! ", 8)
exit
endif

If _Singleton("kmblocker", 0)=0 Then
	Exit
EndIf

FileSetAttrib ($famfilterpac,"-RS", 1)

if $cmdline[0]=0 then
famfilterconfig()
endif

if $cmdline[0]=1 then
famfilterconfig()
elseif $cmdline[0]=2 then
quickblock()
else
exit
endif

func famfilterconfig()

if $cmdline[0]=0 then
$blocksite=("examplewebsite.com")
else
$blocksite=$cmdline[1]
endif

Dim $content

$FileList=_FileListToArray(@scriptDir, "familyfilter.pac", 1)

For $X = 1 to $Filelist[0]
$Find1 = "//dimantibegin"
$retval = _FileReadToArray($famfilterpac, $content)
for $iLine1 = 1 to $content[0] step 1
if StringInStr($content[$iLine1], $find1) then
;msgbox(0, "INFO", $iLine1)
ClipPut ($iLine1)
endif
next
next

$firstline=ClipGet ( )

For $X = 1 to $Filelist[0]
$Find2= "//dimantiend"
$retval = _FileReadToArray($famfilterpac, $content)
for $iLine2 = 1 to $content[0] step 1
if StringInStr($content[$iLine2], $find2) then
;msgbox(0, "INFO", $iLine2)
ClipPut ($iLine2)
endif
next
next

$endline=ClipGet ( )
;msgbox(0, "INFO",$firstline)
;msgbox(0, "INFO",$endline)

$arbetween=$endline-$firstline
;msgbox(0, "INFO",$arbetween)
$betarray=$arbetween+1


$array = ""
$lblTxt= ""
_FileReadToArray($famfilterpac, $array)
For $I = $firstline+1 to $endline-1;; or whatever number of lines or Ubound($array) -1
   ;msgbox(4096, "Array Output", $array[$I])
  $lblTxt &= $array[$I]
Next


ClipPut("")
	$pentrim=( @LF & $lblTxt)
	$remini1=StringReplace($pentrim, "|| shExpMatch(host, ", "")
	$reminix=StringReplace($remini1, "*", "")
	$remini2=StringReplace($reminix, """", "")
	$remini=StringReplace($remini2, ")", "|")
	$first=StringInStr($remini, "|" , "", 1)
	$initial=StringMid($remini, 1, $first-1)
	;msgbox(0, "INFO",$remini)
	;msgbox(0, "INFO",$initial)
    $famfilter=GUICreate("FamilyFilter Config", 310, 134)

    $blocklist=GUICtrlCreateCombo("", 10, 20, 180, 100,BitOr($CBS_DROPDOWNLIST, $WS_VSCROLL))
	$ubButton=GUICtrlCreateButton("unblock", 200, 20, 100)
    if $arbetween<2 then
    $Label1=GUICtrlCreateLabel("Blocked domains list:" & " " & "0", 10, 3, 160, 15)
    GUICtrlSetState ($blocklist, $GUI_DISABLE)
    GUICtrlSetState ($ubButton, $GUI_DISABLE)
    else
    $Label1=GUICtrlCreateLabel("Blocked domains list:" & " " & $arbetween-1, 10, 3, 160, 15)
    GUICtrlSetData($blocklist, $remini, $initial)
    endif
     $Label2=GUICtrlCreateLabel("Add domains:", 10, 48, 160, 15)
     $domadd=GUICtrlCreateInput($blocksite, 10, 64, 180, 20)
     $dombButton=GUICtrlCreateButton("block", 200, 64, 100)
     $exitconf=GUICtrlCreateButton("exit", 200, 98, 100)
     $Label3=GUICtrlCreateLabel("enter domain address above and click the block button", 10, 88, 180, 35)
    GUISetState()

While 1
$msg=GUIGetMsg()
Select
	Case $msg=$GUI_EVENT_CLOSE
	Exit
	Case $msg=$ubButton
	GUICtrlSetData($Label3, "enter domain address above and click the block button")
	$getblocked=GUICtrlRead($blocklist)
	;msgbox(0, "INFO",$getblocked)
	$getitem=_GUICtrlComboBox_GetCurSel($blocklist)
	;msgbox(0, "INFO",$getitem)
	$domline=$firstline+$getitem+1
	;msgbox(0, "INFO",$domline)
	_FileWriteToLine($famfilterpac, $domline, "", 1)
	

		$update=GUICtrlSetData($blocklist, "", "")
Dim $content
$FileList=_FileListToArray(@scriptDir, "familyfilter.pac", 1)
For $X = 1 to $Filelist[0]
$Find1 = "//dimantibegin"
$retval = _FileReadToArray($famfilterpac, $content)
for $iLine1 = 1 to $content[0] step 1
if StringInStr($content[$iLine1], $find1) then
ClipPut ($iLine1)
endif
next
next
$firstline=ClipGet ( )
For $X = 1 to $Filelist[0]
$Find2= "//dimantiend"
$retval = _FileReadToArray($famfilterpac, $content)
for $iLine2 = 1 to $content[0] step 1
if StringInStr($content[$iLine2], $find2) then
ClipPut ($iLine2)
endif
next
next
$endline=ClipGet ( )
$arbetween=$endline-$firstline
$betarray=$arbetween+1
$array = ""
$lblTxt= ""
_FileReadToArray($famfilterpac, $array)
For $I = $firstline+1 to $endline-1;; or whatever number of lines or Ubound($array) -1
   ;msgbox(4096, "Array Output", $array[$I])
  $lblTxt &= $array[$I]
Next
	$pentrim=( @LF & $lblTxt)
	$remini1=StringReplace($pentrim, "|| shExpMatch(host, ", "")
	$reminix=StringReplace($remini1, "*", "")
	$remini2=StringReplace($reminix, """", "")
	$remini=StringReplace($remini2, ")", "|")
	$first=StringInStr($remini, "|" , "", 1)
	$initial=StringMid($remini, 1, $first-1)
    if $arbetween<2 then
    $Label1=GUICtrlCreateLabel("Blocked domains list:" & " " & "0", 10, 3, 160, 15)
    GUICtrlSetState ($blocklist, $GUI_DISABLE)
    GUICtrlSetState ($ubButton, $GUI_DISABLE)
    else
    $Label1=GUICtrlCreateLabel("Blocked domains list:" & " " & $arbetween-1, 10, 3, 160, 15)
    GUICtrlSetData($blocklist, $remini, $initial)
    GUICtrlSetData($Label1, "Blocked domains list:" & " " & $arbetween-1)
    

    endif

	Case $msg=$dombButton
	$getaddom=GUICtrlRead( $domadd)
	$prop1=StringReplace($getaddom, "http://", "")
$prop2=StringReplace($prop1, "https://", "")
$prop3=StringReplace($prop2, "ftp://", "")
$prop4=StringReplace($prop3, "gopher://", "")
$prop5=StringReplace($prop4, "/", "", 1)
$prop6=StringReplace($prop5, "www.", ".", 1)
$prop7=StringReplace($prop6, "www2.", ".", 1)
	$chk=$prop7
$hcontent=FileRead($famfilterpac)
$foolproofchk=StringInStr( $hcontent, $chk)

if $chk="" or StringIsSpace( $chk)=1 or StringInStr($chk, " ")>0 or StringInStr($chk, "?")>0 or StringInStr($chk, "|")>0 or StringInStr($chk, """")>0 or StringInStr($chk, "$")>0 or StringInStr($chk, "&")>0 or StringInStr($chk, "#")>0 or StringInStr($chk, "!")>0 or StringInStr($chk, "(")>0 or StringInStr($chk, ")")>0 or StringInStr($chk, "[")>0 or StringInStr($chk, "]")>0 or StringInStr($chk, "{")>0 or StringInStr($chk, "}")>0 or StringInStr($chk, "@")>0 or StringInStr($chk, "$")>0 or StringInStr($chk, "%")>0 or StringInStr($chk, "^")>0 or StringInStr($chk, "*")>0 or StringInStr($chk, "\")>0 or StringInStr($chk, ";")>0 or StringInStr($chk, ",")>0 or StringInStr($chk, "<")>0 or StringInStr($chk, ">")>0 or StringInStr($chk, "'")>0 or StringInStr($chk, """")>0 or StringInStr($chk, "~")>0 or StringInStr($chk, ".")=0 then
GUICtrlSetData($Label3, "invalid domain address, make sure to enter a proper domain address")
elseif $foolproofchk>0 then 
GUICtrlSetData($Label3, "the domain address you have entered is already blocked")
else
Dim $content
$FileList=_FileListToArray(@scriptDir, "familyfilter.pac", 1)
For $X = 1 to $Filelist[0]
$Find2= "//dimantiend"
$retval = _FileReadToArray($famfilterpac, $content)
for $iLine2 = 1 to $content[0] step 1
if StringInStr($content[$iLine2], $find2) then
;msgbox(0, "INFO", $iLine2)
ClipPut ($iLine2)
endif
next
next
$closecustom=("//dimantiend")
$endline=ClipGet ( )
;msgbox(0, "INFO",$endline)
$blockstrg=("|| shExpMatch(host, " &"""" & "*" & $chk & """" & ")")
_FileWriteToLine($famfilterpac , $endline, $blockstrg, 1)
_FileWriteToLine($famfilterpac , $endline+1, $closecustom & @CRLF, 1)
$update=GUICtrlSetData($blocklist, "", "")
Dim $content
$FileList=_FileListToArray(@scriptDir, "familyfilter.pac", 1)
For $X = 1 to $Filelist[0]
$Find1 = "//dimantibegin"
$retval = _FileReadToArray($famfilterpac, $content)
for $iLine1 = 1 to $content[0] step 1
if StringInStr($content[$iLine1], $find1) then
ClipPut ($iLine1)
endif
next
next
$firstline=ClipGet ( )
For $X = 1 to $Filelist[0]
$Find2= "//dimantiend"
$retval = _FileReadToArray($famfilterpac, $content)
for $iLine2 = 1 to $content[0] step 1
if StringInStr($content[$iLine2], $find2) then
ClipPut ($iLine2)
endif
next
next
$endline=ClipGet ( )
$arbetween=$endline-$firstline
$betarray=$arbetween+1
$array = ""
$lblTxt= ""
_FileReadToArray($famfilterpac, $array)
For $I = $firstline+1 to $endline-1;; or whatever number of lines or Ubound($array) -1
   ;msgbox(4096, "Array Output", $array[$I])
  $lblTxt &= $array[$I]
Next
	$pentrim=( @LF & $lblTxt)
	$remini1=StringReplace($pentrim, "|| shExpMatch(host, ", "")
	$reminix=StringReplace($remini1, "*", "")
	$remini2=StringReplace($reminix, """", "")
	$remini=StringReplace($remini2, ")", "|")
	$first=StringInStr($remini, "|" , "", 1)
	$initial=StringMid($remini, 1, $first-1)
    if $arbetween<2 then
    $Label1=GUICtrlCreateLabel("Blocked domains list:" & " " & "0", 10, 3, 160, 15)
    GUICtrlSetState ($blocklist, $GUI_DISABLE)
    GUICtrlSetState ($ubButton, $GUI_DISABLE)
    else
    $Label1=GUICtrlCreateLabel("Blocked domains list:" & " " & $arbetween-1, 10, 3, 160, 15)
    GUICtrlSetData($blocklist, $remini, $initial)
    GUICtrlSetData($Label1, "Blocked domains list:" & " " & $arbetween-1)
    endif
GUICtrlSetData($Label3, "domain address has been added successfully and is now blocked")
        GUICtrlSetState ($blocklist, $GUI_enable)
    GUICtrlSetState ($ubButton, $GUI_enable)
ClipPut ("")
endif

	Case $msg=$exitconf
	Exit

	EndSelect
    WEnd
endfunc

func quickblock()
	$getaddom=$cmdline[2]
	$prop1=StringReplace($getaddom, "http://", "")
$prop2=StringReplace($prop1, "https://", "")
$prop3=StringReplace($prop2, "ftp://", "")
$prop4=StringReplace($prop3, "gopher://", "")
$prop5=StringReplace($prop4, "/", "", 1)
$prop6=StringReplace($prop5, "www.", ".", 1)
$prop7=StringReplace($prop6, "www2.", ".", 1)
	$chk=$prop7
$hcontent=FileRead($famfilterpac)
$foolproofchk=StringInStr( $hcontent, $chk)
if $foolproofchk>0 then 
ControlSetText("[CLASS:KMeleon Browser Window]", "", 59393, "The domain  [" & $getaddom & "]  is already filtered!  ")
msgbox(48, "ALERT: will not block", "The domain  [" & $getaddom & "]  is already filtered!  ", 8)
else
Dim $content
$FileList=_FileListToArray(@scriptDir, "familyfilter.pac", 1)
For $X = 1 to $Filelist[0]
$Find2= "//dimantiend"
$retval = _FileReadToArray($famfilterpac, $content)
for $iLine2 = 1 to $content[0] step 1
if StringInStr($content[$iLine2], $find2) then
;msgbox(0, "INFO", $iLine2)
ClipPut ($iLine2)
endif
next
next
$closecustom=("//dimantiend")
$endline=ClipGet ( )
;msgbox(0, "INFO",$endline)
$blockstrg=("|| shExpMatch(host, " &"""" & "*" & $chk & """" & ")")
_FileWriteToLine($famfilterpac , $endline, $blockstrg, 1)
_FileWriteToLine($famfilterpac , $endline+1, $closecustom & @CRLF, 1)
ClipPut ("")
ControlSetText("[CLASS:KMeleon Browser Window]", "", 59393, " this domain is now filtered through familyfilter :  " & "[" & $getaddom & "]")
sleep(888)
ControlSetText("[CLASS:KMeleon Browser Window]", "", 59393, " this domain is now filtered through familyfilter :  " & "[" & $getaddom & "]")
sleep(888)
ControlSetText("[CLASS:KMeleon Browser Window]", "", 59393, " this domain is now filtered through familyfilter :  " & "[" & $getaddom & "]")
sleep(888)
ControlSetText("[CLASS:KMeleon Browser Window]", "", 59393, " this domain is now filtered through familyfilter :  " & "[" & $getaddom & "]")
sleep(888)
ControlSetText("[CLASS:KMeleon Browser Window]", "", 59393, " this domain is now filtered through familyfilter :  " & "[" & $getaddom & "]")
sleep(888)
ControlSetText("[CLASS:KMeleon Browser Window]", "", 59393, " this domain is now filtered through familyfilter :  " & "[" & $getaddom & "]")
sleep(888)
ControlSetText("[CLASS:KMeleon Browser Window]", "", 59393, " this domain is now filtered through familyfilter :  " & "[" & $getaddom & "]")
sleep(888)
ControlSetText("[CLASS:KMeleon Browser Window]", "", 59393, " this domain is now filtered through familyfilter :  " & "[" & $getaddom & "]")
sleep(888)
ControlSetText("[CLASS:KMeleon Browser Window]", "", 59393, " this domain is now filtered through familyfilter :  " & "[" & $getaddom & "]")
endif
endfunc
 